Legrand / Raritan Xerus™ JSON-RPC API for Remote Access Devices like KX4-101, KX3G2

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
radm::DsamDeviceManager Interface Reference

## Classes
struct | DeviceAttachedEvent
| Event: A DSAM device was connected. More...
struct | DeviceChangedEvent
| Event: Connected DSAM devices list has changed. More...
struct | DeviceRemovedEvent
| Event: A DSAM device was disconnected. More...
struct | KeywordMappingChangedEvent
| Event: The keyword mapping was changed. More...
struct | UpdateHistoryEntry
| DSAM firmware update history entry. More...

## Public Types
enum | UpdateHistoryStatus { SUCCESSFUL , FAILED , INCOMPLETE }
| Firmware update history status More...

## Public Member Functions
vector< DsamDevice > | getDsamDevices ()
| Get DSAM devices connected to the device.
string | getAvailableFirmwareVersion ()
| Get version of the DSAM firmware available for update.
vector< UpdateHistoryEntry > | getUpdateHistory ()
| Fetch the DSAM firmware update history.
void | startFirmwareUpdate (in vector< DsamDevice > dsams)
| Start firmware update on the given devices.
map< string, vector< SerialAccessPort > > | getKeywordMapping ()
| Get serial device keyword mapping.
int | setKeywordMapping (in map< string, vector< SerialAccessPort > > mapping)
| Set serial device keyword mapping.

## Public Attributes
constant int | ERR_INVALID_ARGUMENT = 1

## Detailed Description

Definition at line 9 of file DsamDeviceManager.idl.

## Member Enumeration Documentation

## ◆ UpdateHistoryStatus

enum radm::DsamDeviceManager::UpdateHistoryStatus

Firmware update history status

Enumerator
SUCCESSFUL | The update was successfully completed.
FAILED | The update failed.
INCOMPLETE | The update was not completed.

Definition at line 15 of file DsamDeviceManager.idl.

## Member Function Documentation

## ◆ getAvailableFirmwareVersion()

string radm::DsamDeviceManager::getAvailableFirmwareVersion | ( |  | ) |

Get version of the DSAM firmware available for update.

Returns
  Version number string of the available DSAM firmware

## ◆ getDsamDevices()

vector< DsamDevice > radm::DsamDeviceManager::getDsamDevices | ( |  | ) |

Get DSAM devices connected to the device.

Returns
  List of connected DSAM devices

## ◆ getKeywordMapping()

map< string, vector< SerialAccessPort > > radm::DsamDeviceManager::getKeywordMapping | ( |  | ) |

Get serial device keyword mapping.

An alert is sent in the serial protocol whenever a configured keyword is encountered in the serial port data.

Returns
  Keyword mapping, using the keywords as map keys and the serial ports the keyword is configured for as value

## ◆ getUpdateHistory()

vector< UpdateHistoryEntry > radm::DsamDeviceManager::getUpdateHistory | ( |  | ) |

Fetch the DSAM firmware update history.

Returns
  DSAM firmware update history entries

## ◆ setKeywordMapping()

int radm::DsamDeviceManager::setKeywordMapping | ( | in map< string, vector< SerialAccessPort > > | mapping | ) |

Set serial device keyword mapping.

The following constraints apply:

- There must not be more than 16 keywords per port
- Ports for a given keyword must be unique (no duplicates)

Parameters

  mapping | New keyword mapping, using keyword as key and serial ports the keyword is configured for as value

Returns
  0 on success
  1 if the mapping is invalid

## ◆ startFirmwareUpdate()

void radm::DsamDeviceManager::startFirmwareUpdate | ( | in vector< DsamDevice > | dsams | ) |

Start firmware update on the given devices.

Parameters

  dsams | DSAM devices to update

## Member Data Documentation

## ◆ ERR_INVALID_ARGUMENT

constant int radm::DsamDeviceManager::ERR_INVALID_ARGUMENT = 1

Definition at line 10 of file DsamDeviceManager.idl.

The documentation for this interface was generated from the following file:

- DsamDeviceManager.idl